﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace i8014W_Basic_Info_Csharp
{
    public partial class I_8014CW_I_9014C : Form
    {
        public Int16 slotIndex = 0;
        public Int16 maxCh = 0;
        public I_8014CW_I_9014C()
        {
            InitializeComponent();
        }
        private void I_8014CW_I_9014C_Load(object sender, EventArgs e)
        {
            Tips_list.Items.Clear();
            Tips_list.Items.Add("For I-8014CW and I-9014C,");
            Tips_list.Items.Add("Read gain and offset values require 'pac8014W.Read_mA_GainOffset' function");
            Tips_list.Items.Add("Each 'ch' has a pair of gain and offset values");
            Tips_list.Items.Add("Step 4 : Click 'Read AI' button");
        }
        private void Read_AI_I8014CW_brn_Click(object sender, EventArgs e)
        {
            Int16 ch = 0;
            Int16 gain = 4;
            float fVal = 0;
            short hVal = 0;
            TextBox[] dara_arr = { CH0_Data_txt, CH1_Data_txt, CH2_Data_txt, CH3_Data_txt, CH4_Data_txt, CH5_Data_txt, CH6_Data_txt, CH7_Data_txt };
            for (ch = 0; ch < maxCh; ch++)
            {
                if (HEX_Format_ckb.Checked)
                {
                    //read HEX format AI data
                    pac8014WNet.pac8014W.ReadAIHex(slotIndex, ch, gain, ref hVal);
                    dara_arr[ch].Text = hVal.ToString("X4");
                }
                else
                {
                    //for I-8014Cw and I-9014C, range always is +/- 20mA
                    pac8014WNet.pac8014W.ReadAI(slotIndex, ch, gain, ref fVal);
                    dara_arr[ch].Text = fVal.ToString("F03");
                }
            }
        }
        private void btnExit_Click(object sender, EventArgs e)
        {
            Close();
        }
        public void I_8014CW_I_9014C_Read_Gain_Offset()
        {
            Int16 ch = 0;
            UInt16 gainValue = 0;
            Int16 offsetValue = 0;
            TextBox[] gain_arr = { CH0_Gain_txt, CH1_Gain_txt, CH2_Gain_txt, CH3_Gain_txt, CH4_Gain_txt, CH5_Gain_txt, CH6_Gain_txt, CH7_Gain_txt };
            TextBox[] offset_arr = { CH0_Offset_txt, CH1_Offset_txt, CH2_Offset_txt, CH3_Offset_txt, CH4_Offset_txt, CH5_Offset_txt, CH6_Offset_txt, CH7_Offset_txt };
            for (ch = 0; ch < maxCh; ch++)
            {
                pac8014WNet.pac8014W.Read_mA_GainOffset((short)slotIndex, (short)ch, ref gainValue, ref offsetValue);
                gain_arr[ch].Text = gainValue.ToString();
                offset_arr[ch].Text = offsetValue.ToString();
            }
        }
    }
}